//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  DimGray
#property indicator_color2  DimGray
#property indicator_color3  Silver
#property indicator_color4  DeepSkyBlue
#property indicator_color5  DeepSkyBlue
#property indicator_color6  PaleVioletRed
#property indicator_color7  PaleVioletRed
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2
#property indicator_minimum -1.1
#property indicator_maximum +1.1


//
//
//
//
//

extern string CorrSymbol  = "";
extern int    CorrPeriod  = 30;
extern int    CorrLag     =  1;
extern int    CorrPrice   = PRICE_CLOSE;

//
//
//
//
//

double corr[];
double corrUa[];
double corrUb[];
double corrDa[];
double corrDb[];
double peup[];
double pedn[];
double state[];
bool   returnBars;
string indicatorFileName;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
         SetIndexBuffer(0,peup);
         SetIndexBuffer(1,pedn);
         SetIndexBuffer(2,corr);
         SetIndexBuffer(3,corrUa);
         SetIndexBuffer(4,corrUb);
         SetIndexBuffer(5,corrDa);
         SetIndexBuffer(6,corrDb);
         SetIndexBuffer(7,state);
            if (CorrSymbol=="") CorrSymbol=Symbol();
               returnBars        = (CorrSymbol=="returnBars");
               indicatorFileName = WindowExpertName();
   IndicatorShortName("Person coefficient "+Symbol()+" to "+CorrSymbol+" ("+CorrPeriod+","+CorrLag+")");
   return(0); 
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double diff[];
double difl[];

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted(); double pers = MathSqrt(CorrPeriod);
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
         if (returnBars) { corr[0] = limit; return(0); }
         if (CorrSymbol!=Symbol()) limit = MathMin(Bars-1,iCustom(CorrSymbol,0,indicatorFileName,"returnBars",0,0));
         if (ArraySize(diff)!=Bars) { ArrayResize(diff,Bars); ArrayResize(difl,Bars); }

   //
   //
   //
   //
   //

   if (state[limit]==-1) CleanPoint(limit,corrDa,corrDb);
   if (state[limit]== 1) CleanPoint(limit,corrUa,corrUb);
   for(i=limit,r=Bars-i-1; i>=0; i--,r++)
   {
         diff[r] = iMA(NULL      ,0,1,0,MODE_SMA,CorrPrice,i);
         difl[r] = iMA(CorrSymbol,0,1,0,MODE_SMA,CorrPrice,i+CorrLag);
  
         //
         //
         //
         //
         //
         
         double dev1 = iDeviation(diff,CorrPeriod,r);
         double dev2 = iDeviation(difl,CorrPeriod,r);
            if (dev1 != 0 && dev2 != 0)
                  corr[i] = iCovariance(diff,difl,CorrPeriod,r)/(dev1*dev2);
            else  corr[i] = 0;
         double pe = 0.6745*(1-MathPow(corr[i],2))/pers;
            peup[i]   =  6.0*pe;
            pedn[i]   = -6.0*pe;
            corrUa[i] = EMPTY_VALUE;
            corrUb[i] = EMPTY_VALUE;
            corrDa[i] = EMPTY_VALUE;
            corrDa[i] = EMPTY_VALUE;
            state[i]  = state[i+1];
               if (corr[i]>peup[i])                    state[i] =  1;
               if (corr[i]<pedn[i])                    state[i] = -1;
               if (corr[i]<peup[i] && corr[i]>pedn[i]) state[i] =  0;
               if (state[i]== 1) PlotPoint(i,corrUa,corrUb,corr);
               if (state[i]==-1) PlotPoint(i,corrDa,corrDb,corr);
   }
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double iDeviation(double& array[], int size, int i, bool isSample = false)
{
   double avg = array[i]; for (int k=1; k<size; k++) avg  += array[i-k];  avg /= size;
   double sum = 0;
      for (k=0; k<size; k++) sum += (array[i-k]-avg)*(array[i-k]-avg);
   
      if (isSample)         
            return(MathSqrt(sum/(size-1)));
      else  return(MathSqrt(sum/(size)));
}

//
//
//
//
//

double iCovariance(double& indep[], double& depen[], int size, int i, bool isSample = false)
{
   double avgi = indep[i]; for (int k=1; k<size; k++) avgi += indep[i-k]; avgi /= size;
   double avgd = depen[i]; for (    k=1; k<size; k++) avgd += depen[i-k]; avgd /= size;
   double sum = 0;
      for (k=0; k<size; k++) sum += (indep[i-k]-avgi)*(depen[i-k]-avgd);

      if (isSample)         
            return(sum/(size-1));
      else  return(sum/(size));
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}